#pragma once

#include <hilbert/kernel/utility.hpp>

namespace hilbert::kernel::input {

  enum : uint32_t {
    LEFT_SHIFT  = 1 <<  8,
    RIGHT_SHIFT = 1 <<  9,
    LEFT_CTRL   = 1 << 10,
    RIGHT_CTRL  = 1 << 11,
    LEFT_ALT    = 1 << 12,
    RIGHT_ALT   = 1 << 13,
    LEFT_WIN    = 1 << 14,
    RIGHT_WIN   = 1 << 15,
    CAPS_LOCK   = 1 << 16,
    NUM_LOCK    = 1 << 17,
    BREAK       = 1 << 18,
  };

  extern utility::queue<uint32_t> *key_queue;

  //must be post switch to kernel page tables and mounting of file systems
  void init_input();

}
